using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Controls.Primitives;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.scrollViewer.ViewChanged                               += scrollViewer_ViewChanged;
            this.zoomModeComboBox.SelectionChanged                      += zoomModeComboBox_SelectionChanged;
            this.zoomSlider.ValueChanged                                += zoomSlider_ValueChanged;
            this.horizontalScrollModeComboBox.SelectionChanged          += horizontalScrollModeComboBox_SelectionChanged;
            this.verticalScrollModeComboBox.SelectionChanged            += verticalScrollModeComboBox_SelectionChanged;
            this.horizontalScrollbarVisibilityComboBox.SelectionChanged += horizontalScrollbarVisibilityComboBox_SelectionChanged;
            this.verticalScrollbarVisibilityComboBox.SelectionChanged   += verticalScrollbarVisibilityComboBox_SelectionChanged;

            this.zoomModeComboBox.SelectedIndex                      = 1;
            this.horizontalScrollModeComboBox.SelectedIndex          = 1;
            this.verticalScrollModeComboBox.SelectedIndex            = 1;
            this.horizontalScrollbarVisibilityComboBox.SelectedIndex = 1;
            this.verticalScrollbarVisibilityComboBox.SelectedIndex   = 1;

            this.scrollViewer.ZoomToFactor(4.0f);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ũ    óϱ - scrollViewer_ViewChanged(sender, e)

        /// <summary>
        /// ũ    óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void scrollViewer_ViewChanged(object sender, ScrollViewerViewChangedEventArgs e)
        {
            if(!e.IsIntermediate)
            {
                this.zoomSlider.Value = this.scrollViewer.ZoomFactor;
            }
        }

        #endregion
        #region ZoomMode ޺ ڽ   óϱ - zoomModeComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// ZoomMode ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void zoomModeComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(this.scrollViewer != null && this.zoomSlider != null)
            {
                if(sender is ComboBox comboBox)
                {
                    this.scrollViewer.ZoomMode = (ZoomMode)comboBox.SelectedIndex;
                    this.zoomSlider.IsEnabled  = comboBox.SelectedIndex == 1;

                    if(!this.zoomSlider.IsEnabled)
                    {
                        scrollViewer.ZoomToFactor(1.0f);
                    }
                }
            }
        }

        #endregion
        #region Zoom ̴   óϱ - zoomSlider_ValueChanged(sender, e)

        /// <summary>
        /// Zoom ̴   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void zoomSlider_ValueChanged(object sender, RangeBaseValueChangedEventArgs e)
        {
            if(this.scrollViewer != null)
            {
                this.scrollViewer.ChangeView(null, null, (float)e.NewValue);
            }
        }

        #endregion
        #region Horizontal ScrollMode ޺ ڽ   óϱ - horizontalScrollModeComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// Horizontal ScrollMode ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void horizontalScrollModeComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(this.scrollViewer != null)
            {
                if(sender is ComboBox comboBox)
                {
                    this.scrollViewer.HorizontalScrollMode = (ScrollMode)comboBox.SelectedIndex;
                }
            }
        }

        #endregion
        #region Vertical ScrollMode ޺ ڽ   óϱ - verticalScrollModeComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// Vertical ScrollMode ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void verticalScrollModeComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(this.scrollViewer != null)
            {
                if(sender is ComboBox comboBox)
                {
                    this.scrollViewer.VerticalScrollMode = (ScrollMode)comboBox.SelectedIndex;
                }
            }
        }

        #endregion
        #region Horizontal ScrollbarVisibility ޺ ڽ   óϱ - horizontalScrollbarVisibilityComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// Horizontal ScrollbarVisibility ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void horizontalScrollbarVisibilityComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(this.scrollViewer != null)
            {
                if(sender is ComboBox comboBox)
                {
                    this.scrollViewer.HorizontalScrollBarVisibility = (ScrollBarVisibility)comboBox.SelectedIndex;
                }
            }
        }

        #endregion
        #region Vertical ScrollbarVisibility ޺ ڽ   óϱ - verticalScrollbarVisibilityComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// Vertical ScrollbarVisibility ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void verticalScrollbarVisibilityComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(this.scrollViewer != null)
            {
                if(sender is ComboBox comboBox)
                {
                    this.scrollViewer.VerticalScrollBarVisibility = (ScrollBarVisibility)comboBox.SelectedIndex;
                }
            }
        }

        #endregion
    }
}